
 '****************************************************************
'*  Name    : Thermo873A.BAS                                      *
'*  Author  : =ibragimnk=                                         *
'*  Notice  : =ibragimnk=                                         *
'*          : All Rights Reserved                                 *
'*  Date    : 28.05.2015                                          *
'*  Version : 1.0                                                 *
'*  Notes   :  http://www.picbasic.ru/forum/5-528-1#5922  *
'*          :                                                     *
'****************************************************************
'*  Name    :   873 ,     
Device 16F873A
Reminders = OFF
'Config INTOSC_OSC_NOCLKOUT , MCLRE_OFF,  WDT_OFF ,  PWRTE_ON , BODEN_OFF , LVP_OFF ,  CP_OFF 
;     ...
Reminders = On
Declare All_Digital = On                                '   


;!!!!!!!!!!!!!!!!!!!!!!!!!!!
;***************************
;###########################
;===========================

    Dim Digits As Byte
    Dim Digit1 As Byte
    Dim Digit2 As Byte
    Dim Digit3 As Byte
    Dim Digit4 As Byte
    Dim Number As Word
    Dim Selector As Byte
    Dim MaskA As Byte
    Dim MaskSel As Byte
    Dim OutA As Byte
    Dim IndDigit As Byte
    Dim DigitDisp As Byte
;!!!!!!!!!!!!!!!!!!!!!!!!!!!
;***************************
;###########################
;===========================



Symbol PS0 = OPTION_REG.0      ' Prescaler Rate Select
Symbol PS1 = OPTION_REG.1      ' Prescaler Rate Select
Symbol PS2 = OPTION_REG.2      ' Prescaler Rate Select
Symbol PSA = OPTION_REG.3      ' Prescaler Assignment
Symbol T0SE = OPTION_REG.4     ' TMR0 Source Edge Select
Symbol T0CS = OPTION_REG.5     ' TMR0 Clock Source Select
Symbol INTEDG = OPTION_REG.6   ' Interrupt Edge Select
Symbol NOT_RBPU = OPTION_REG.7 ' PORTB Pull-up Enable

Symbol RBIF = INTCON.0 ' RB Port Interrupt Flag
Symbol INTF = INTCON.1 ' RB0 External Interrupt Flag
Symbol T0IF = INTCON.2 ' TMR0 Overflow Interrupt Flag
Symbol RBIE = INTCON.3 ' RB Port Change Interrupt Enable
Symbol INTE = INTCON.4 ' RB0 External Interrupt Enable
Symbol T0IE = INTCON.5 ' TMR0 Overflow Interrupt Enable
Symbol PEIE = INTCON.6 ' Peripheral Interrupt Enable
Symbol GIE = INTCON.7  ' Global Interrupt Enable


       On_Interrupt GoTo IntL
       GoTo Init
;  
IntL:
     Context Save
          T0IF = 0        ;      0
          
          
          PORTA = (PORTA & $F0) | $F     ;  
          
          FSR = IndDigit  ; 
          PORTB = INDF    ;   
          
          MaskSel = ~Selector & MaskA    ; 
          OutA = PORTA & $F0             ;  
          PORTA = OutA | MaskSel         ; 
     
          Dec IndDigit                   ;   1   
          
          Selector =  Selector << 1      ;   
          If Selector = %00010000 Then   ;    
             Selector = %00000001        ;  
             IndDigit = VarPtr(Digit4)
          EndIf   
     Context Restore
             

Init:
        
                       '
    TRISA = %11110000	       '   A 4-7 
    TRISB = %00000000	       '    
    TRISC = %11111000	       '   C 3-7 
    
    OPTION_REG = %00000101      ;;;;;  0 1 : 64
    T0IE = 1                    ;;;;;   
    GIE = 1                     ;;;;;      
    
    Selector = %00000001        ;    4- 
    MaskA = %00001111           ;
    IndDigit = VarPtr(Digit4)   ;      
                                ;   
;--------------------------     -------------------------------------------------------   
main:

     ;    
     Number = 1820
     
     DigitDisp = Dig Number, 3
     GoSub LOOKS
     Digit1 = Digits
     
     DigitDisp = Dig Number, 2
     GoSub LOOKS
     Digit2 = Digits
     
     DigitDisp = Dig Number, 1
     GoSub LOOKS
     Digit3 = Digits
     
     DigitDisp = Dig Number, 0
     GoSub LOOKS
     Digit4 = Digits



							

                                 
GoTo main      

LOOKS:
        ;       
        Digits = LookUpL DigitDisp,[63,6,91,79,102,109,125,7,127,111]
Return

    
End
        
        
        

